﻿using Kreta.Framework.Security;
using SDA.DataProvider;

namespace Kreta.Framework.Session
{
    public class SystemSession : UserContext
    {
        protected internal const string SessionId = "SYSTEM";

        public SystemSession() :
            base(new LoginInfo(SessionId, 0, "127.0.0.1", int.MaxValue, SessionId), new SystemTransactionContext(SDAServer.Instance.GetOrganizationIdentifier()))
        {
        }

        private class SystemTransactionContext : TransactionContext
        {
            public SystemTransactionContext(string intezmenyAzonosito) : base(intezmenyAzonosito)
            {
            }

            internal override SDAConnection CreateConnection()
            {
                var connectionString = SDAServer.Instance.GetSystemConnectionString(IntezmenyAzonosito);
                return SDAServer.Instance.CreateConnection(connectionString);
            }
        }
    }
}
